diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-includes/cache.php ./wordpress-3.3/wp-includes/cache.php
*** ./wordpress-3.2.1/wp-includes/cache.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-includes/cache.php	2011-10-18 15:20:59.000000000 -0500
***************
*** 9,37 ****
   */
  
  /**
!  * Adds data to the cache, if the cache key doesn't aleady exist.
   *
   * @since 2.0.0
   * @uses $wp_object_cache Object Cache Class
   * @see WP_Object_Cache::add()
   *
!  * @param int|string $key The cache ID to use for retrieval later
   * @param mixed $data The data to add to the cache store
!  * @param string $flag The group to add the cache to
   * @param int $expire When the cache data should be expired
   * @return unknown
   */
! function wp_cache_add($key, $data, $flag = '', $expire = 0) {
  	global $wp_object_cache;
  
! 	return $wp_object_cache->add($key, $data, $flag, $expire);
  }
  
  /**
   * Closes the cache.
   *
   * This function has ceased to do anything since WordPress 2.5. The
!  * functionality was removed along with the rest of the persistant cache. This
   * does not mean that plugins can't implement this function when they need to
   * make sure that the cache is cleaned up after WordPress no longer needs it.
   *
--- 9,37 ----
   */
  
  /**
!  * Adds data to the cache, if the cache key doesn't already exist.
   *
   * @since 2.0.0
   * @uses $wp_object_cache Object Cache Class
   * @see WP_Object_Cache::add()
   *
!  * @param int|string $key The cache key to use for retrieval later
   * @param mixed $data The data to add to the cache store
!  * @param string $group The group to add the cache to
   * @param int $expire When the cache data should be expired
   * @return unknown
   */
! function wp_cache_add($key, $data, $group = '', $expire = 0) {
  	global $wp_object_cache;
  
! 	return $wp_object_cache->add($key, $data, $group, $expire);
  }
  
  /**
   * Closes the cache.
   *
   * This function has ceased to do anything since WordPress 2.5. The
!  * functionality was removed along with the rest of the persistent cache. This
   * does not mean that plugins can't implement this function when they need to
   * make sure that the cache is cleaned up after WordPress no longer needs it.
   *
***************
*** 44,63 ****
  }
  
  /**
!  * Removes the cache contents matching ID and flag.
   *
   * @since 2.0.0
   * @uses $wp_object_cache Object Cache Class
   * @see WP_Object_Cache::delete()
   *
!  * @param int|string $id What the contents in the cache are called
!  * @param string $flag Where the cache contents are grouped
   * @return bool True on successful removal, false on failure
   */
! function wp_cache_delete($id, $flag = '') {
  	global $wp_object_cache;
  
! 	return $wp_object_cache->delete($id, $flag);
  }
  
  /**
--- 44,81 ----
  }
  
  /**
!  * Decrement numeric cache item's value
!  *
!  * @since 3.3.0
!  * @uses $wp_object_cache Object Cache Class
!  * @see WP_Object_Cache::decr()
!  *
!  * @param int|string $key The cache key to increment
!  * @param int $offset The amount by which to decrement the item's value.  Default is 1.
!  * @param string $group The group the key is in.
!  * @return false|int False on failure, the item's new value on success.
!  */
! function wp_cache_decr( $key, $offset = 1, $group = '' ) {
! 	global $wp_object_cache;
! 
! 	return $wp_object_cache->decr( $key, $offset, $group );
! }
! 
! /**
!  * Removes the cache contents matching key and group.
   *
   * @since 2.0.0
   * @uses $wp_object_cache Object Cache Class
   * @see WP_Object_Cache::delete()
   *
!  * @param int|string $key What the contents in the cache are called
!  * @param string $group Where the cache contents are grouped
   * @return bool True on successful removal, false on failure
   */
! function wp_cache_delete($key, $group = '') {
  	global $wp_object_cache;
  
! 	return $wp_object_cache->delete($key, $group);
  }
  
  /**
***************
*** 76,96 ****
  }
  
  /**
!  * Retrieves the cache contents from the cache by ID and flag.
   *
   * @since 2.0.0
   * @uses $wp_object_cache Object Cache Class
   * @see WP_Object_Cache::get()
   *
!  * @param int|string $id What the contents in the cache are called
!  * @param string $flag Where the cache contents are grouped
   * @return bool|mixed False on failure to retrieve contents or the cache
   *		contents on success
   */
! function wp_cache_get($id, $flag = '') {
  	global $wp_object_cache;
  
! 	return $wp_object_cache->get($id, $flag);
  }
  
  /**
--- 94,133 ----
  }
  
  /**
!  * Retrieves the cache contents from the cache by key and group.
   *
   * @since 2.0.0
   * @uses $wp_object_cache Object Cache Class
   * @see WP_Object_Cache::get()
   *
!  * @param int|string $key What the contents in the cache are called
!  * @param string $group Where the cache contents are grouped
!  * @param bool $force Whether to force an update of the local cache from the persistent cache (default is false)
   * @return bool|mixed False on failure to retrieve contents or the cache
   *		contents on success
   */
! function wp_cache_get( $key, $group = '', $force = false ) {
! 	global $wp_object_cache;
! 
! 	return $wp_object_cache->get( $key, $group, $force );
! }
! 
! /**
!  * Increment numeric cache item's value
!  *
!  * @since 3.3.0
!  * @uses $wp_object_cache Object Cache Class
!  * @see WP_Object_Cache::incr()
!  *
!  * @param int|string $key The cache key to increment
!  * @param int $offset The amount by which to increment the item's value.  Default is 1.
!  * @param string $group The group the key is in.
!  * @return false|int False on failure, the item's new value on success.
!  */
! function wp_cache_incr( $key, $offset = 1, $group = '' ) {
  	global $wp_object_cache;
  
! 	return $wp_object_cache->incr( $key, $offset, $group );
  }
  
  /**
***************
*** 100,106 ****
   * @global WP_Object_Cache $wp_object_cache WordPress Object Cache
   */
  function wp_cache_init() {
! 	$GLOBALS['wp_object_cache'] =& new WP_Object_Cache();
  }
  
  /**
--- 137,143 ----
   * @global WP_Object_Cache $wp_object_cache WordPress Object Cache
   */
  function wp_cache_init() {
! 	$GLOBALS['wp_object_cache'] = new WP_Object_Cache();
  }
  
  /**
***************
*** 112,125 ****
   *
   * @param int|string $key What to call the contents in the cache
   * @param mixed $data The contents to store in the cache
!  * @param string $flag Where to group the cache contents
   * @param int $expire When to expire the cache contents
!  * @return bool False if cache ID and group already exists, true on success
   */
! function wp_cache_replace($key, $data, $flag = '', $expire = 0) {
  	global $wp_object_cache;
  
! 	return $wp_object_cache->replace($key, $data, $flag, $expire);
  }
  
  /**
--- 149,162 ----
   *
   * @param int|string $key What to call the contents in the cache
   * @param mixed $data The contents to store in the cache
!  * @param string $group Where to group the cache contents
   * @param int $expire When to expire the cache contents
!  * @return bool False if cache key and group already exist, true on success
   */
! function wp_cache_replace($key, $data, $group = '', $expire = 0) {
  	global $wp_object_cache;
  
! 	return $wp_object_cache->replace($key, $data, $group, $expire);
  }
  
  /**
***************
*** 131,144 ****
   *
   * @param int|string $key What to call the contents in the cache
   * @param mixed $data The contents to store in the cache
!  * @param string $flag Where to group the cache contents
   * @param int $expire When to expire the cache contents
!  * @return bool False if cache ID and group already exists, true on success
   */
! function wp_cache_set($key, $data, $flag = '', $expire = 0) {
  	global $wp_object_cache;
  
! 	return $wp_object_cache->set($key, $data, $flag, $expire);
  }
  
  /**
--- 168,181 ----
   *
   * @param int|string $key What to call the contents in the cache
   * @param mixed $data The contents to store in the cache
!  * @param string $group Where to group the cache contents
   * @param int $expire When to expire the cache contents
!  * @return bool False if cache key and group already exist, true on success
   */
! function wp_cache_set($key, $data, $group = '', $expire = 0) {
  	global $wp_object_cache;
  
! 	return $wp_object_cache->set($key, $data, $group, $expire);
  }
  
  /**
***************
*** 206,220 ****
  	var $cache = array ();
  
  	/**
- 	 * Cache objects that do not exist in the cache
- 	 *
- 	 * @var array
- 	 * @access private
- 	 * @since 2.0.0
- 	 */
- 	var $non_existent_objects = array ();
- 
- 	/**
  	 * The amount of times the cache data was already stored in the cache.
  	 *
  	 * @since 2.5.0
--- 243,248 ----
***************
*** 246,269 ****
  	 *
  	 * @uses WP_Object_Cache::get Checks to see if the cache already has data.
  	 * @uses WP_Object_Cache::set Sets the data after the checking the cache
! 	 *		contents existance.
  	 *
  	 * @since 2.0.0
  	 *
! 	 * @param int|string $id What to call the contents in the cache
  	 * @param mixed $data The contents to store in the cache
  	 * @param string $group Where to group the cache contents
  	 * @param int $expire When to expire the cache contents
! 	 * @return bool False if cache ID and group already exists, true on success
  	 */
! 	function add( $id, $data, $group = 'default', $expire = '' ) {
  		if ( empty ($group) )
  			$group = 'default';
  
! 		if (false !== $this->get($id, $group))
  			return false;
  
! 		return $this->set($id, $data, $group, $expire);
  	}
  
  	/**
--- 274,300 ----
  	 *
  	 * @uses WP_Object_Cache::get Checks to see if the cache already has data.
  	 * @uses WP_Object_Cache::set Sets the data after the checking the cache
! 	 *		contents existence.
  	 *
  	 * @since 2.0.0
  	 *
! 	 * @param int|string $key What to call the contents in the cache
  	 * @param mixed $data The contents to store in the cache
  	 * @param string $group Where to group the cache contents
  	 * @param int $expire When to expire the cache contents
! 	 * @return bool False if cache key and group already exist, true on success
  	 */
! 	function add( $key, $data, $group = 'default', $expire = '' ) {
! 		if ( wp_suspend_cache_addition() )
! 			return false;
! 
  		if ( empty ($group) )
  			$group = 'default';
  
! 		if (false !== $this->get($key, $group))
  			return false;
  
! 		return $this->set($key, $data, $group, $expire);
  	}
  
  	/**
***************
*** 281,312 ****
  	}
  
  	/**
! 	 * Remove the contents of the cache ID in the group
  	 *
! 	 * If the cache ID does not exist in the group and $force parameter is set
  	 * to false, then nothing will happen. The $force parameter is set to false
  	 * by default.
  	 *
- 	 * On success the group and the id will be added to the
- 	 * $non_existent_objects property in the class.
- 	 *
  	 * @since 2.0.0
  	 *
! 	 * @param int|string $id What the contents in the cache are called
  	 * @param string $group Where the cache contents are grouped
  	 * @param bool $force Optional. Whether to force the unsetting of the cache
! 	 *		ID in the group
  	 * @return bool False if the contents weren't deleted and true on success
  	 */
! 	function delete($id, $group = 'default', $force = false) {
  		if (empty ($group))
  			$group = 'default';
  
! 		if (!$force && false === $this->get($id, $group))
  			return false;
  
! 		unset ($this->cache[$group][$id]);
! 		$this->non_existent_objects[$group][$id] = true;
  		return true;
  	}
  
--- 312,366 ----
  	}
  
  	/**
! 	 * Decrement numeric cache item's value
! 	 *
! 	 * @since 3.3.0
! 	 *
! 	 * @param int|string $key The cache key to increment
! 	 * @param int $offset The amount by which to decrement the item's value.  Default is 1.
! 	 * @param string $group The group the key is in.
! 	 * @return false|int False on failure, the item's new value on success.
! 	 */
! 	function decr( $key, $offset = 1, $group = 'default' ) {
! 		if ( ! isset( $this->cache[ $group ][ $key ] ) )
! 			return false;
! 
! 		if ( ! is_numeric( $this->cache[ $group ][ $key ] ) )
! 			$this->cache[ $group ][ $key ] = 0;
! 
! 		$offset = (int) $offset;
! 
! 		$this->cache[ $group ][ $key ] -= $offset;
! 
! 		if ( $this->cache[ $group ][ $key ] < 0 )
! 			$this->cache[ $group ][ $key ] = 0;
! 
! 		return $this->cache[ $group ][ $key ];
! 	}
! 
! 	/**
! 	 * Remove the contents of the cache key in the group
  	 *
! 	 * If the cache key does not exist in the group and $force parameter is set
  	 * to false, then nothing will happen. The $force parameter is set to false
  	 * by default.
  	 *
  	 * @since 2.0.0
  	 *
! 	 * @param int|string $key What the contents in the cache are called
  	 * @param string $group Where the cache contents are grouped
  	 * @param bool $force Optional. Whether to force the unsetting of the cache
! 	 *		key in the group
  	 * @return bool False if the contents weren't deleted and true on success
  	 */
! 	function delete($key, $group = 'default', $force = false) {
  		if (empty ($group))
  			$group = 'default';
  
! 		if (!$force && false === $this->get($key, $group))
  			return false;
  
! 		unset ($this->cache[$group][$key]);
  		return true;
  	}
  
***************
*** 327,388 ****
  	 * Retrieves the cache contents, if it exists
  	 *
  	 * The contents will be first attempted to be retrieved by searching by the
! 	 * ID in the cache group. If the cache is hit (success) then the contents
  	 * are returned.
  	 *
! 	 * On failure, the $non_existent_objects property is checked and if the
! 	 * cache group and ID exist in there the cache misses will not be
! 	 * incremented. If not in the nonexistent objects property, then the cache
! 	 * misses will be incremented and the cache group and ID will be added to
! 	 * the nonexistent objects.
  	 *
  	 * @since 2.0.0
  	 *
! 	 * @param int|string $id What the contents in the cache are called
  	 * @param string $group Where the cache contents are grouped
  	 * @return bool|mixed False on failure to retrieve contents or the cache
  	 *		contents on success
  	 */
! 	function get($id, $group = 'default') {
  		if ( empty ($group) )
  			$group = 'default';
  
! 		if ( isset ($this->cache[$group][$id]) ) {
  			$this->cache_hits += 1;
! 			if ( is_object($this->cache[$group][$id]) )
! 				return clone $this->cache[$group][$id];
  			else
! 				return $this->cache[$group][$id];
  		}
  
- 		if ( isset ($this->non_existent_objects[$group][$id]) )
- 			return false;
- 
- 		$this->non_existent_objects[$group][$id] = true;
  		$this->cache_misses += 1;
  		return false;
  	}
  
  	/**
  	 * Replace the contents in the cache, if contents already exist
  	 *
  	 * @since 2.0.0
  	 * @see WP_Object_Cache::set()
  	 *
! 	 * @param int|string $id What to call the contents in the cache
  	 * @param mixed $data The contents to store in the cache
  	 * @param string $group Where to group the cache contents
  	 * @param int $expire When to expire the cache contents
  	 * @return bool False if not exists, true if contents were replaced
  	 */
! 	function replace($id, $data, $group = 'default', $expire = '') {
  		if (empty ($group))
  			$group = 'default';
  
! 		if ( false === $this->get($id, $group) )
  			return false;
  
! 		return $this->set($id, $data, $group, $expire);
  	}
  
  	/**
--- 381,462 ----
  	 * Retrieves the cache contents, if it exists
  	 *
  	 * The contents will be first attempted to be retrieved by searching by the
! 	 * key in the cache group. If the cache is hit (success) then the contents
  	 * are returned.
  	 *
! 	 * On failure, the number of cache misses will be incremented.
  	 *
  	 * @since 2.0.0
  	 *
! 	 * @param int|string $key What the contents in the cache are called
  	 * @param string $group Where the cache contents are grouped
+ 	 * @param string $force Whether to force a refetch rather than relying on the local cache (default is false)
  	 * @return bool|mixed False on failure to retrieve contents or the cache
  	 *		contents on success
  	 */
! 	function get( $key, $group = 'default', $force = false) {
  		if ( empty ($group) )
  			$group = 'default';
  
! 		if ( isset ($this->cache[$group][$key]) ) {
  			$this->cache_hits += 1;
! 			if ( is_object($this->cache[$group][$key]) )
! 				return clone $this->cache[$group][$key];
  			else
! 				return $this->cache[$group][$key];
  		}
  
  		$this->cache_misses += 1;
  		return false;
  	}
  
  	/**
+ 	 * Increment numeric cache item's value
+ 	 *
+ 	 * @since 3.3.0
+ 	 *
+ 	 * @param int|string $key The cache key to increment
+ 	 * @param int $offset The amount by which to increment the item's value.  Default is 1.
+ 	 * @param string $group The group the key is in.
+ 	 * @return false|int False on failure, the item's new value on success.
+ 	 */
+ 	function incr( $key, $offset = 1, $group = 'default' ) {
+ 		if ( ! isset( $this->cache[ $group ][ $key ] ) )
+ 			return false;
+ 
+ 		if ( ! is_numeric( $this->cache[ $group ][ $key ] ) )
+ 			$this->cache[ $group ][ $key ] = 0;
+ 
+ 		$offset = (int) $offset;
+ 
+ 		$this->cache[ $group ][ $key ] += $offset;
+ 
+ 		if ( $this->cache[ $group ][ $key ] < 0 )
+ 			$this->cache[ $group ][ $key ] = 0;
+ 
+ 		return $this->cache[ $group ][ $key ];
+ 	}
+ 
+ 	/**
  	 * Replace the contents in the cache, if contents already exist
  	 *
  	 * @since 2.0.0
  	 * @see WP_Object_Cache::set()
  	 *
! 	 * @param int|string $key What to call the contents in the cache
  	 * @param mixed $data The contents to store in the cache
  	 * @param string $group Where to group the cache contents
  	 * @param int $expire When to expire the cache contents
  	 * @return bool False if not exists, true if contents were replaced
  	 */
! 	function replace($key, $data, $group = 'default', $expire = '') {
  		if (empty ($group))
  			$group = 'default';
  
! 		if ( false === $this->get($key, $group) )
  			return false;
  
! 		return $this->set($key, $data, $group, $expire);
  	}
  
  	/**
***************
*** 402,408 ****
  	 * Sets the data contents into the cache
  	 *
  	 * The cache contents is grouped by the $group parameter followed by the
! 	 * $id. This allows for duplicate ids in unique groups. Therefore, naming of
  	 * the group should be used with care and should follow normal function
  	 * naming guidelines outside of core WordPress usage.
  	 *
--- 476,482 ----
  	 * Sets the data contents into the cache
  	 *
  	 * The cache contents is grouped by the $group parameter followed by the
! 	 * $key. This allows for duplicate ids in unique groups. Therefore, naming of
  	 * the group should be used with care and should follow normal function
  	 * naming guidelines outside of core WordPress usage.
  	 *
***************
*** 412,424 ****
  	 *
  	 * @since 2.0.0
  	 *
! 	 * @param int|string $id What to call the contents in the cache
  	 * @param mixed $data The contents to store in the cache
  	 * @param string $group Where to group the cache contents
  	 * @param int $expire Not Used
  	 * @return bool Always returns true
  	 */
! 	function set($id, $data, $group = 'default', $expire = '') {
  		if ( empty ($group) )
  			$group = 'default';
  
--- 486,498 ----
  	 *
  	 * @since 2.0.0
  	 *
! 	 * @param int|string $key What to call the contents in the cache
  	 * @param mixed $data The contents to store in the cache
  	 * @param string $group Where to group the cache contents
  	 * @param int $expire Not Used
  	 * @return bool Always returns true
  	 */
! 	function set($key, $data, $group = 'default', $expire = '') {
  		if ( empty ($group) )
  			$group = 'default';
  
***************
*** 428,438 ****
  		if ( is_object($data) )
  			$data = clone $data;
  
! 		$this->cache[$group][$id] = $data;
! 
! 		if ( isset($this->non_existent_objects[$group][$id]) )
! 			unset ($this->non_existent_objects[$group][$id]);
! 
  		return true;
  	}
  
--- 502,508 ----
  		if ( is_object($data) )
  			$data = clone $data;
  
! 		$this->cache[$group][$key] = $data;
  		return true;
  	}
  
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-includes/canonical.php ./wordpress-3.3/wp-includes/canonical.php
*** ./wordpress-3.2.1/wp-includes/canonical.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-includes/canonical.php	2011-11-20 12:32:42.000000000 -0600
***************
*** 14,20 ****
   *
   * Search engines consider www.somedomain.com and somedomain.com to be two
   * different URLs when they both go to the same location. This SEO enhancement
!  * prevents penality for duplicate content by redirecting all incoming links to
   * one or the other.
   *
   * Prevents redirection for feeds, trackbacks, searches, comment popup, and
--- 14,20 ----
   *
   * Search engines consider www.somedomain.com and somedomain.com to be two
   * different URLs when they both go to the same location. This SEO enhancement
!  * prevents penalty for duplicate content by redirecting all incoming links to
   * one or the other.
   *
   * Prevents redirection for feeds, trackbacks, searches, comment popup, and
***************
*** 175,184 ****
  
  						// Create the destination url for this taxonomy
  						$tax_url = parse_url($tax_url);
! 						if ( ! empty($tax_url['query']) ) { // Taxonomy accessable via ?taxonomy=..&term=.. or any custom qv..
  							parse_str($tax_url['query'], $query_vars);
  							$redirect['query'] = add_query_arg($query_vars, $redirect['query']);
! 						} else { // Taxonomy is accessable via a "pretty-URL"
  							$redirect['path'] = $tax_url['path'];
  						}
  
--- 175,184 ----
  
  						// Create the destination url for this taxonomy
  						$tax_url = parse_url($tax_url);
! 						if ( ! empty($tax_url['query']) ) { // Taxonomy accessible via ?taxonomy=..&term=.. or any custom qv..
  							parse_str($tax_url['query'], $query_vars);
  							$redirect['query'] = add_query_arg($query_vars, $redirect['query']);
! 						} else { // Taxonomy is accessible via a "pretty-URL"
  							$redirect['path'] = $tax_url['path'];
  						}
  
***************
*** 218,225 ****
  				$addl_path = !empty( $addl_path ) ? trailingslashit($addl_path) : '';
  				if ( get_query_var( 'withcomments' ) )
  					$addl_path .= 'comments/';
! 				$addl_path .= user_trailingslashit( 'feed/' . ( ( get_default_feed() ==  get_query_var('feed') || 'feed' == get_query_var('feed') ) ? '' : get_query_var('feed') ), 'feed' );
  				$redirect['query'] = remove_query_arg( 'feed', $redirect['query'] );
  			}
  
  			if ( get_query_var('paged') > 0 ) {
--- 218,242 ----
  				$addl_path = !empty( $addl_path ) ? trailingslashit($addl_path) : '';
  				if ( get_query_var( 'withcomments' ) )
  					$addl_path .= 'comments/';
! 				if ( ( 'rss' == get_default_feed() && 'feed' == get_query_var('feed') ) || 'rss' == get_query_var('feed') )
! 					$addl_path .= user_trailingslashit( 'feed/' . ( ( get_default_feed() == 'rss2' ) ? '' : 'rss2' ), 'feed' );
! 				else
! 					$addl_path .= user_trailingslashit( 'feed/' . ( ( get_default_feed() ==  get_query_var('feed') || 'feed' == get_query_var('feed') ) ? '' : get_query_var('feed') ), 'feed' );
  				$redirect['query'] = remove_query_arg( 'feed', $redirect['query'] );
+ 			} elseif ( is_feed() && 'old' == get_query_var('feed') ) {
+ 				$old_feed_files = array(
+ 					'wp-atom.php'         => 'atom',
+ 					'wp-commentsrss2.php' => 'comments_rss2',
+ 					'wp-feed.php'         => get_default_feed(),
+ 					'wp-rdf.php'          => 'rdf',
+ 					'wp-rss.php'          => 'rss2',
+ 					'wp-rss2.php'         => 'rss2',
+ 				);
+ 				if ( isset( $old_feed_files[ basename( $redirect['path'] ) ] ) ) {
+ 					$redirect_url = get_feed_link( $old_feed_files[ basename( $redirect['path'] ) ] );
+ 					wp_redirect( $redirect_url, 301 );
+ 					die();
+ 				}
  			}
  
  			if ( get_query_var('paged') > 0 ) {
***************
*** 263,268 ****
--- 280,286 ----
  				unset( $_parsed_query['name'] );
  		}
  
+ 		$_parsed_query = array_map( 'rawurlencode', $_parsed_query );
  		$redirect_url = add_query_arg( $_parsed_query, $redirect_url );
  	}
  
***************
*** 295,300 ****
--- 313,321 ----
  		// Clean up empty query strings
  		$redirect['query'] = trim(preg_replace( '#(^|&)(p|page_id|cat|tag)=?(&|$)#', '&', $redirect['query']), '&');
  
+ 		// Redirect obsolete feeds
+ 		$redirect['query'] = preg_replace( '#(^|&)feed=rss(&|$)#', '$1feed=rss2$3', $redirect['query'] );
+ 
  		// Remove redundant leading ampersands
  		$redirect['query'] = preg_replace( '#^\??&*?#', '', $redirect['query'] );
  	}
